{$M 65520,0,655360}
Program Imagine;

CONST MAX = 250;
Var Fotografie: Array[1..MAX, 1..MAX] Of Byte;
    n, i, j   : Integer;
    Fin, Fout : text;

Function Verifica(x1, y1, x2, y2, Pixel: Integer): Boolean;
{functia determina daca zona de coordonate x1, y1, x2, y1
 are doar pixeli 0 sau doar pixeli 1}
Var i, j: Integer;
Begin
  For i := x1 To x2 Do
    For j := y1 To y2 Do
      If Fotografie[i, j] <> Pixel Then
        {am gasit un pixel diferit de Pixel}
        Begin
          Verifica := FALSE;
          Exit;
        End;
  Verifica := TRUE; {toti pixelii sunt identici cu Pixel}
End;

Function Lungime_Compresie(x1, y1, x2, y2: Integer): LongInt;
Var Mijloc_x, Mijloc_y: Integer;
Begin
  If Verifica(x1, y1, x2, y2, Fotografie[x1, y1]) Then
    {daca toti pixelii sunt identici}
    Begin
      Lungime_Compresie := 2;{pentru aceasta zona dimensiunea compresiei este 2}
(* evenntual pot construi imaginea compresata
        If Fotografie[x1, y1]=1 Then
        Write('01 ')
      Else
        Write('00 ')
*)
    End
  Else                {altfel}
    Begin
(*      Write('1( ');        *)
      {impart zona in 4 parti}
      Mijloc_x := (x1+x2) div 2; {mijlocul pe orizontala}
      Mijloc_y := (y1+y2) div 2; {mijlocul pe verticala}
      {apoi, evident, numarul de pixeli pentru compresie este
       1 + suma pixelilor necesari pentru cele 4 zone}
      Lungime_Compresie := 1
                      + Lungime_Compresie(x1, Mijloc_y+1, Mijloc_x, y2)
                      + Lungime_Compresie(Mijloc_x+1, Mijloc_y+1, x2, y2)
                      + Lungime_Compresie(x1, y1, Mijloc_x, Mijloc_y)
                      + Lungime_Compresie(Mijloc_x+1, y1, x2, Mijloc_y);
(*      Write(') ')          *)
    End;
End;

Begin
(*  WriteLn;     *)
  Assign(Fin, 'imagine.in'); Reset(Fin);
  ReadLn(Fin, n);
  For i := 1 To n Do
    For j:= 1 To n Do
      Read(Fin, Fotografie[i,j]);
  Assign(Fout, 'imagine.out'); ReWrite(Fout);
  {apelez functia de calculare a numarului de pixeli necesari pentru
   intreaga fotografie}
  WriteLn(Fout, Lungime_Compresie(1, 1, n, n));
  Close(Fout);
End.
