#include <stdio.h>
#define MAX 250

FILE *Fin, *Fout;

char imagine[MAX][MAX];

int PixeliEgali(int x1, int y1, int x2, int y2, int Pixel)
//functia determina daca zona de coordonate x1, y1, x2, y1 are doar pixeli 0 sau doar pixeli 1
{
  int i, j;
  for (i=x1; i<=x2; i++)
    for (j=y1; j<=y2; j++)
      if (imagine[i][j]!=Pixel)
        //am gasit un pixel diferit de Pixel
          return 0;
  return 1; //toti pixelii sunt identici cu Pixel
}

unsigned long Lungime_Compresie(int x1, int y1, int x2, int y2)
{
  int Mijloc_x, Mijloc_y;
  if (PixeliEgali(x1, y1, x2, y2, imagine[x1][y1]))
    //daca toti pixelii sunt identici
      return 2;    //pentru aceasta zona dimensiunea compresiei este 2
  else                //altfel
    {
    //impart imaginea in patru subimagini
      Mijloc_x = (x1+x2)/2; //mijlocul pe orizontala
      Mijloc_y = (y1+y2)/2; //mijlocul pe verticala
      //apoi, evident, numarul de pixeli pentru compresie este
      //1 + suma pixelilor necesari pentru cele 4 subimagini
      return 1 + Lungime_Compresie(x1, Mijloc_y+1, Mijloc_x, y2)
                + Lungime_Compresie(Mijloc_x+1, Mijloc_y+1, x2, y2)
                + Lungime_Compresie(x1, y1, Mijloc_x, Mijloc_y)
                + Lungime_Compresie(Mijloc_x+1, y1, x2, Mijloc_y);
    }
}

int main()
{
  int n, i, j;
  Fin = fopen("imagine.in", "rt");
  fscanf(Fin, "%d", &n);
  for (i=0; i<n; i++)
    for (j=0; j<n; j++)
      fscanf(Fin, "%d", &imagine[i][j]);
  fclose(Fin);
  Fout = fopen("imagine.out", "wt");
//apelez functia de calculare a numarului de pixeli necesari pentru intreaga fotografie
  fprintf(Fout, "%lu", Lungime_Compresie(0, 0, n-1, n-1));
  fclose(Fout);
  return 0;
}
