#include <stdio.h>
#define INPUT_FILE  "win.in"
#define OUTPUT_FILE "win.out"
#define NMAX 100

int N;              //N reprezinta numarul de ferestre
struct { int ls, ld, cs, cd;} f[NMAX]; 
//f - vector cu N componente in care retinem ferestrele
int inchisa[NMAX];
/* inchisa[i]=0 daca fereastra i este deschisa, 
    respectiv 1 daca fereastra i este inchisa           */ 
int rez; 
/* rez  variabila globala in care calculam numarul total 
   de click-uri necesare                                */

void citire(void)
{ int i;
  FILE * fin = fopen(INPUT_FILE, "r");
  fscanf(fin, "%d", &N);
  for (i=0; i<N; ++i)
      fscanf(fin, "%d %d %d %d", &f[i].ls, &f[i].cs, 
                 &f[i].ld, &f[i].cd);
  fclose(fin);
}

int peste(int a, int b)
/* functia returneaza valoarea 1 daca fereastra a este peste fereastra coltul din dreapta sus al ferestrei b si 0 in caz contrar  */
{ if (f[a].ls <= f[b].ls && f[a].ld >= f[b].ls &&
      f[a].cs <= f[b].cd && f[a].cd >= f[b].cd)
      return 1;
  return 0;                        
}

void inchide(int nr)
{/* functia inchide fereastra cu numarul nr */
  int i;
  for (i=N-1; i>=nr+1; i--)
    if (!inchisa[i] && peste(i, nr))
        inchide(i);
  inchisa[nr]=1;
  ++rez;                           
}

void rezolvare(void)
{
  int i;
  for (i=0; i<N; i++) inchisa[i] = 0;
  rez = 0;
  inchide(0);                      
}
void afisare(void)
{ FILE * fout = fopen(OUTPUT_FILE,"w");
  fprintf(fout,"%d\n", rez);
  fclose(fout);                    
}

int main(void)
{ citire();
  rezolvare();
  afisare();  return 0; 
}

