Program Reteua;
CONST NMax = 10;
      NrMaxS = 1 ShL NMax;  {1 ShL 10 inseamna 2^10 = 1024}
{ShL – Shift Left – reprezentarea binara a lui 1 (00...001) se deplaseaza cu 10 pozitii spre stanga, 
                    generand 00...010000000000, adica 2^10} 
Var n, m: Integer;
    A, B: Array[0..NrMaxS, 0..NMax] Of Byte;
    R: Array[0..NrMaxS, 0..NrMaxS] Of LongInt;
    f, g: Text;

Procedure Afisare;
Var i, j: Integer;
Begin
  Assign(g, 'retea.out'); ReWrite(g);
  For i := 0 To (1 ShL n) - 1 Do
    Begin
      For j := 0 To (1 ShL m) - 1 Do Write(g, R[i][j], ' ');
      WriteLn(g)
    End;
  Close(g)
End;

Procedure GenerareCodA(x: Integer);
Var i, j: Integer;
Begin
  If x=1 Then A[1][0] := 1
  Else
    Begin
      GenerareCodA(x-1);
      For i := (1 ShL (x-1))-1 DownTo 0 Do
        Begin
          For j := 0 To x-2 Do
            A[(1 ShL x)-i-1][j] := A[i][j];
          A[(1 ShL x)-i-1][x-1] := 1;
        End
    End
End;

Procedure GenerareCodB(x: Integer);
Var i, j: Integer;
Begin
  If x=1 Then B[1][0] := 1
  Else
    Begin
      GenerareCodB(x-1);
      For i := (1 ShL (x-1))-1 DownTo 0 Do
        Begin
          For j := 0 To x-2 Do
            B[(1 ShL x)-i-1][j] := B[i][j];
          B[(1 ShL x)-i-1][x-1] := 1;
        End
    End
End;

Procedure FaRetea;
Var i, j, k: Integer;
Begin
  For i := 0 To 1 ShL n -1 Do
    For j := 0 To 1 ShL m -1 Do
      Begin
        R[i][j] := 0;
        For k := 0 To n-1 Do R[i][j] := 2*R[i][j]+A[i][k];
        For k := 0 To m-1 Do R[i][j] := 2*R[i][j]+B[j][k];
      End;
End;

Begin
  Assign(f, 'retea.in'); Reset(f); 
  ReadLn(f, n, m);
  GenerareCodA(n);
  GenerareCodB(m);
  FaRetea;
  Afisare
End.
